/////////////////////////////////////////////////////////////////
//Beispiel Kapitel Fraktale: Attraktor Henon Fraktal 
//////////////////////////////////////////////////////////////

// Parameter für die Henon Iteration
float alpha = 1.4;
float beta = 0.3;

//Bildausschnitt zu Beginn:
float xMin =-2.5; 
float xMax = 2.5;
float yMin = -0.5; 
float yMax = 0.5;

//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, sollte man mit double-Werten 
// rechnen
double dx ;
double dy ;
double xStart = 0;
double yStart = 0;
double xStartNeu = 0;
double yStartNeu = 0;
int anzahlIterationenPS;//Anzahl der Iterationen für jeden Startpunkt
int anzahlStartPunkte;
int punkteZaehler = 0;

///////////////////////////////////////////////////////////////////////////
//Initialisierungen  
///////////////////////////////////////////////////////////////////////////

void setup() { 
  size(800, 800);
  background(255);
  dx = 2;
  dy = 0.4;
  anzahlIterationenPS = 100;//Bei nur wenigen anzahlIterationenPS höhere 
  anzahlStartPunkte = 100;//anzahlStartPunkte wählen
  colorMode(HSB);
}

//////////////////////////////////////////////////////////

void iteriere(double xAlt,double yAlt) {  
  stroke(color( punkteZaehler%256, 255, 255));
  int i=0;
  while (i <= anzahlIterationenPS) {
    if (Math.abs(xAlt)< 100000 && Math.abs(yAlt)< 100000) {
      double xNeu = 1-alpha*(xAlt*xAlt)+ yAlt; 
      double yNeu = beta*xAlt; 
      // erzeuge den jeweiligen Punkt im Bild
      float xK = round(map((float)xNeu, xMin, xMax, 0, width));                 
      float yK = round(map((float)yNeu, yMin, yMax, height, 0));    
      point(xK, yK);  
      xAlt = xNeu;
      yAlt = yNeu;
    }
    i++;
  }
  punkteZaehler++;//print(punkteZaehler+" ");
  if(punkteZaehler == anzahlStartPunkte) println("fertig!"); //zur Kontrolle
}

///////////////////////////////////////////////////////////////////////////

void draw() {
 
  if(punkteZaehler <= anzahlStartPunkte){
    //Um die verschiedenen Startpunkte farblich zu unterscheiden
    
    xStartNeu = xStart+random(-(float)dx,(float)dx);
    yStartNeu = yStart+random(-(float)dy,(float)dy);
   
    //Iterierte Punkte zeichnen für einen Zufallsstartpunkt
    iteriere(xStartNeu,yStartNeu); 
    punkteZaehler++;
  }
}

//////////////////////////////////////

void keyPressed() {  
  if (key == 'd') background(255);
  if (key == 's') save("bild.png");
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird vergrößert
//////////////////////////////////////////////////////

void mousePressed() {  
  background(255);
  // mache den Bildausschnitt kleiner
  float xMinNeu = map(mouseX, 0, width, xMin, xMax)-(xMax-xMin)/5;
  float xMaxNeu = map(mouseX, 0, width, xMin, xMax)+(xMax-xMin)/5;
  float yMinNeu = map(mouseY, 0, height,yMax, yMin)-(yMax-yMin)/5;
  float yMaxNeu = map(mouseY, 0, height,yMax, yMin)+(yMax-yMin)/5;
  xMin = xMinNeu; 
  xMax = xMaxNeu; 
  yMin = yMinNeu; 
  yMax = yMaxNeu;
  punkteZaehler = 0;
  anzahlIterationenPS = anzahlIterationenPS*3;
  punkteZaehler = 0;
   
  
}
